/***************************************************************************
 *            twi.h
 *
 *  Tue Oct  6 22:29:59 2009
 *  Copyright  2009  Dirk Broßwick
 *  <sharandac@snafu.de>
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 

#ifndef _TWI_H
	#define _TWI_H

#if defined(__AVR_ATmega644__) || defined(__AVR_ATmega2561__) || defined(__AVR_ATmega32__)
	#define TWI_READ    1
	#define TWI_WRITE   0

	#define	TRUE	1
	#define	FALSE	0

	#define TWI_TIMEOUT_MS	2 // 20ms
#else
	#error "TWI wird für diese Hardwareplatform nicht unterstützt, bitte in der config.h abwählen!"
#endif

	char TWI_Init ( long TWI_Bitrate );
	char TWI_SendAddress ( char Address, char TWI_RW );
	void TWI_SendStart ( void );
	void TWI_SendStop ( void );
	char TWI_Write ( char Data );
	char TWI_ReadAck ( char* pData );
	char TWI_ReadNack ( char* pData );
	
	int TWI_Scan( void );
	
	volatile unsigned int twi_timer_ms;


#endif
